import React from 'react';
import Plot from './Plot';
import Axis from './components/Axis';
import Legend from './components/Legend';
import LineSeries from './components/LineSeries';
import ScatterSeries from './components/ScatterSeries';
export default function PlotObject({ plot: { dimentions, viewportStyle, axes, series, legend, colorScheme }, }) {
    return (React.createElement(Plot, Object.assign({ colorScheme: colorScheme, viewportStyle: viewportStyle }, dimentions),
        axes.map((props) => (React.createElement(Axis, Object.assign({ key: props.id }, props)))),
        legend !== undefined ? React.createElement(Legend, Object.assign({}, legend)) : null,
        series.map(({ type, ...props }, i) => {
            switch (type) {
                case 'line': {
                    // eslint-disable-next-line react/no-array-index-key
                    return React.createElement(LineSeries, Object.assign({ key: `lineseries-${i}` }, props));
                }
                case 'scatter': {
                    // eslint-disable-next-line react/no-array-index-key
                    return React.createElement(ScatterSeries, Object.assign({ key: `scatterseries-${i}` }, props));
                }
                default: {
                    return null;
                }
            }
        })));
}
//# sourceMappingURL=PlotObject.js.map