import React from 'react';
export function Ticks(props) {
    const { hidden, ticks, scale, getPositions, scientific = true, ...otherProps } = props;
    if (hidden)
        return null;
    const elements = ticks.map((tick) => {
        const { line, text } = getPositions(scale(tick));
        return (React.createElement(Tick, Object.assign({ key: tick, line: line, text: text }, otherProps), scientific ? tick.toExponential(2) : tick));
    });
    return React.createElement(React.Fragment, null, elements);
}
export function Tick(props) {
    const { line: { x1: lineX1 = 0, x2: lineX2 = 0, y1: lineY1 = 0, y2: lineY2 = 0 }, text: { x1: textX1 = 0, y1: textY1 = 0 }, style, children, strokeColor = 'black', anchor = 'end', } = props;
    return (React.createElement("g", null,
        React.createElement("line", { x1: lineX1, x2: lineX2, y1: lineY1, y2: lineY2, stroke: strokeColor }),
        React.createElement("text", { x: textX1, y: textY1, textAnchor: anchor, dominantBaseline: "middle", style: { userSelect: 'none', ...style } }, children)));
}
//# sourceMappingURL=Ticks.js.map