import React from 'react';
import { usePlotContext } from '../hooks';
function yTranslation(position, height) {
    switch (position) {
        case 'top': {
            return 20;
        }
        case 'bottom': {
            return height + 64;
        }
        default: {
            throw new Error(`Unknown ${JSON.stringify(position)} position`);
        }
    }
}
export default function Heading({ title, titleStyle, titleClass, subtitle, subtitleStyle, subtitleClass, position = 'top', }) {
    const { width, height, bottom } = usePlotContext();
    const defaultTitleStyle = {
        textAnchor: 'middle',
        fontSize: '16px',
        fontWeight: 'bold',
    };
    const defaultSubtitleStyle = {
        textAnchor: 'middle',
        fontSize: '14px',
        color: 'gray',
    };
    const bottomHeigth = height - bottom;
    const y = yTranslation(position, bottomHeigth);
    return (React.createElement("g", { transform: `translate(${width / 2}, ${y})` },
        React.createElement("text", { style: { ...defaultTitleStyle, ...titleStyle }, className: titleClass }, title),
        subtitle && (React.createElement("text", { transform: "translate(0, 20)", style: { ...defaultSubtitleStyle, ...subtitleStyle }, className: subtitleClass }, subtitle))));
}
//# sourceMappingURL=Heading.js.map