import { Dispatch, ReactNode } from 'react';
import { Shape } from '../types';
interface LabelState {
    label: string;
    shape?: {
        figure: Shape;
        color: string;
        hidden: boolean;
    };
    colorLine: string | null;
}
interface LegendState {
    labels: Array<LabelState>;
}
export declare type ActionType<Action, Payload = void> = Payload extends void ? {
    type: Action;
} : {
    type: Action;
    payload: Payload;
};
declare type LegendAction = ActionType<'ADD_LEGEND_LABEL', LabelState>;
declare type LegendDispatch = Dispatch<LegendAction>;
declare type LegendContext = [LegendState, LegendDispatch];
export declare function useLegend(): LegendContext;
export declare const LegendProvider: (props: {
    children: ReactNode;
}) => JSX.Element;
export {};
