"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const hooks_1 = require("../../hooks");
const utils_1 = require("../../utils");
const Ticks_1 = require("./Ticks");
function BottomAxis({ id, displayGridLines, hidden = false, label, labelSpace, labelStyle, fontSize, tickStyle, hiddenTicks = false, tickEmbedded, tickLength, }) {
    const { axisContext, plotWidth, plotHeight } = hooks_1.usePlotContext();
    // Calculates the main axis values
    const { scale, scientific } = axisContext[id] || {};
    const ticks = react_1.useMemo(() => {
        const ticksNumber = utils_1.calculateTicksNumber(plotWidth, scientific, scale === null || scale === void 0 ? void 0 : scale.domain());
        return (scale === null || scale === void 0 ? void 0 : scale.ticks(ticksNumber)) || [];
    }, [scale, scientific, plotWidth]);
    const range = (scale === null || scale === void 0 ? void 0 : scale.range()) || [0, 0];
    // Create gridlines
    const gridlines = react_1.useMemo(() => {
        if (!displayGridLines || !scale)
            return null;
        return (react_1.default.createElement("g", { className: "gridLines" }, ticks.map((val) => (react_1.default.createElement("line", { key: val, x1: scale(val), x2: scale(val), y1: plotHeight, y2: "0", stroke: "black", strokeDasharray: "2,2", strokeOpacity: 0.5 })))));
    }, [displayGridLines, ticks, scale, plotHeight]);
    const tickDirection = tickEmbedded ? -1 : 1;
    const tickLen = tickDirection * tickLength;
    return (react_1.default.createElement("g", { className: "axis" },
        gridlines,
        !hidden && (react_1.default.createElement("g", { className: "ticks", transform: `translate(0, ${plotHeight})` },
            react_1.default.createElement("line", { x1: range[0], x2: range[1], stroke: "black" }),
            react_1.default.createElement(Ticks_1.Ticks, { scientific: scientific, scale: scale, hidden: hiddenTicks, ticks: ticks, style: tickStyle, anchor: "middle", getPositions: (val) => ({
                    line: { x1: val, x2: val, y2: tickLen },
                    text: { x1: val, y1: 16 },
                }) }))),
        label && !hidden && (react_1.default.createElement("text", { x: plotWidth / 2, y: plotHeight + labelSpace + fontSize, fontSize: fontSize, textAnchor: "middle", style: labelStyle }, label))));
}
exports.default = BottomAxis;
