"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const hooks_1 = require("../../hooks");
const VerticalText_1 = __importDefault(require("../VerticalText"));
const Ticks_1 = require("./Ticks");
function LeftAxis({ id, displayGridLines, hidden = false, label, labelSpace, labelStyle, fontSize, tickStyle, hiddenTicks = false, tickEmbedded, tickLength, }) {
    const { axisContext, plotHeight, plotWidth } = hooks_1.usePlotContext();
    // Calculates the main axis values
    const { scale, scientific } = axisContext[id] || {};
    const ticks = react_1.useMemo(() => (scale === null || scale === void 0 ? void 0 : scale.ticks()) || [], [scale]);
    const range = (scale === null || scale === void 0 ? void 0 : scale.range()) || [0, 0];
    // Create gridlines
    const gridlines = react_1.useMemo(() => {
        if (!displayGridLines || !scale)
            return null;
        return (react_1.default.createElement("g", { className: "gridLines" }, ticks.map((val) => (react_1.default.createElement("line", { key: val, x1: "0", x2: plotWidth, y1: scale(val), y2: scale(val), stroke: "black", strokeDasharray: "2,2", strokeOpacity: 0.5 })))));
    }, [displayGridLines, ticks, scale, plotWidth]);
    const tickDirection = tickEmbedded ? 1 : -1;
    const tickLen = tickDirection * tickLength;
    return (react_1.default.createElement("g", { className: "axis" },
        gridlines,
        !hidden && (react_1.default.createElement("g", { className: "ticks" },
            react_1.default.createElement("line", { y1: range[0], y2: range[1], stroke: "black" }),
            react_1.default.createElement(Ticks_1.Ticks, { scientific: scientific, scale: scale, hidden: hiddenTicks, ticks: ticks, style: tickStyle, getPositions: (y) => ({
                    line: { x2: tickLen, y1: y, y2: y },
                    text: { x1: -8, y1: y },
                }) }))),
        label && !hidden && (react_1.default.createElement(VerticalText_1.default, { label: label, transform: `translate(${0 - fontSize - labelSpace - (scientific ? 14 : 0)}, ${plotHeight / 2})`, dy: fontSize, fontSize: fontSize, style: labelStyle }))));
}
exports.default = LeftAxis;
