"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LegendProvider = exports.useLegend = void 0;
const immer_1 = require("immer");
const react_1 = __importStar(require("react"));
const context = react_1.createContext(null);
function useLegend() {
    const ctx = react_1.useContext(context);
    if (!ctx) {
        throw new Error('context was not initialized');
    }
    return ctx;
}
exports.useLegend = useLegend;
const legendReducer = immer_1.produce((draft, action) => {
    switch (action.type) {
        case 'ADD_LEGEND_LABEL': {
            const { shape, ...other } = action.payload;
            if (draft.labels.some((element) => element.label === other.label)) {
                return;
            }
            draft.labels.push({ ...other, shape });
            return;
        }
        default:
            throw new Error('unreachable');
    }
});
const initialLegendState = {
    labels: [],
};
const LegendProvider = (props) => {
    const ctx = react_1.useReducer(legendReducer, initialLegendState);
    return react_1.default.createElement(context.Provider, { value: ctx }, props.children);
};
exports.LegendProvider = LegendProvider;
